/* grm_config.h.  Generated from grm_config.h.in by configure.  */
/* grm_config.h.in  [input to configure]
 * 
 * System-dependent configuration of Tornado, by autoconf.
 * 
 * This file should be included in all Tornado .c files before
 * anything else, because it may set #define's that control
 * behaviour of system includes and system libraries. An example
 * is large file support.
 * 
 * SVN $Id$
 * SRE, Fri Mar  3 08:03:32 2006 [St. Louis]
 */
#ifndef GRM_CONFIG_INCLUDED
#define GRM_CONFIG_INCLUDED

/* In Inside algorithm implementations, we use a table lookup in
 * grm_FLogsum() to calculate summed probabilities in log
 * space. grm_INTSCALE defines the precision of the calculation; the
 * default of 1000.0 means rounding differences to the nearest 0.001
 * nat. grm_LOGSUM_TBL defines the size of the lookup table; the
 * default of 16000 means entries are calculated for differences of 0
 * to 16.000 nats (when grm_INTSCALE is 1000.0).  e^{-grm_LOGSUM_TBL /
 * p7_INTSCALE} should be on the order of the machine FLT_EPSILON,
 * typically 1.2e-7.
 */
#define grm_INTSCALE     1000.0f
#define grm_LOGSUM_TBL   16000

/* Version info.
 */
#define TORNADO_VERSION "0.3"
#define TORNADO_DATE "Dec 2012"
#define TORNADO_COPYRIGHT "Copyright (C) 2012 Howard Hughes Medical Institute"
#define TORNADO_LICENSE "Freely distributed under the Janelia Farm Software License."

/* Large file support
 * Must precede any header file inclusion.
 */
/* #undef _FILE_OFFSET_BITS */
/* #undef _LARGE_FILES */
/* #undef _LARGEFILE_SOURCE */

/* Debugging verbosity (0=none;3=most verbose)
 */
#define eslDEBUGLEVEL 0

/* System headers
 */
#define HAVE_UNISTD_H 1
#define HAVE_STDINT_H 1
#define HAVE_INTTYPES_H 1
#define HAVE_SYS_TYPES_H 1

/* Types
 */
/* #undef WORDS_BIGENDIAN */
/* #undef int8_t */
/* #undef int16_t */
/* #undef int32_t */
/* #undef int64_t */
/* #undef uint8_t */
/* #undef uint16_t */
/* #undef uint32_t */
/* #undef uint64_t */
/* #undef off_t */

/* Optional packages
 */
/* #undef HAVE_LIBGSL */

/* Optional parallel implementation support
 */
/* #undef HAVE_SSE2 */
/* #undef HAVE_VMX */
#define HAVE_MPI 1

/* Functions
 */
#define HAVE_MKSTEMP 1
#define HAVE_POPEN 1
#define HAVE_STRCASECMP 1
#define HAVE_TIMES 1
#define HAVE_FSEEKO 1

#endif /*GRM_CONFIG_INCLUDED*/
/*****************************************************************
 * @LICENSE@
 *****************************************************************/
